/* ........................................................
		A.VRI.L MLP ver.0.94d1 [LIBRA] (working... almost)
		04.07.2003 00:00
		Ultima versione ok
   ........................................................ */

#include "MatDataSet.h"
#include "HTKDataSet.h"
#include "MemoryDataSet.h"
#include "ClassFormatDataSet.h"
#include "ClassNLLCriterion.h"
#include "OneHotClassFormat.h"
#include "TwoClassFormat.h"
#include "ClassMeasurer.h"
#include "ClassNLLMeasurer.h"
#include "OutputMeasurer.h"
#include "Sequence.h"

#include "StochasticGradient.h"
#include "KFold.h"

#include "ConnectedMachine.h"
#include "Linear.h"
#include "Tanh.h"
#include "Sigmoid.h"
#include "LogSoftMax.h"
#include "TemporalMean.h"

#include "MeanVarNorm.h"
#include "DiskXFile.h"
#include "CmdLine.h"
#include "Random.h"
#include <unistd.h>
#include <stdio.h>

/* Macros (for training and test mode) */
#define TRAIN 0
#define TEST 1

#define NOUTPUTS 2

using namespace Torch;


/* ========================================================
		GLOBAL VARIABLES
   ======================================================== */
	char *inputs_file; /* Train/test MFCC file list */
	char *targets_file; /* Train/test MFCC file list */
	char *valid_inputs_file; /* File list used for validation */
	char *valid_targets_file; /* File list used for validation */
	char *weight_file; /* File for MLP configuration */

	int theclass; /* Class of training file */
	int valid_theclass; /* Class of validation file */

	int max_load; /* Maximum number of vectors for training */
	int max_load_valid; /* Numbers for cross validation */
	real accuracy; /* Train accuracy stop condition */
	real learning_rate; /* Learning rate stop condition */
	real decay; /* Learning rate decay stop condition */
	real weight_decay; /* Weight decay parameter */
	int max_iter; /* Maximum number of iterations */
	int the_seed; /* Random seed */
	int hidden; /* Hidden units */
	int n_train = 1; /* Number of available frames */

	bool balance; /* Balance vector load between classes (to minimum) */
	int load_classzero = 0; /* Vectors load for class zero */
	int load_classone = 0; /* Vectors load for class one */
	int valid_load_classzero = 0; /* Vectors load for class zero (validation) */
	int valid_load_classone = 0; /* Vectors load for class one (validation) */
	int vector_tokens[2]; /* Tokens for vectors */
	int valid_vector_tokens[2]; /* Tokens for vectors (validation) */
	int vectors_processed = 0; /* Vectors loaded */
	int valid_vectors_processed = 0; /* Vectors loaded (validation) */

	char *zero_tag; /* Class zero tag identifier */
	char *dir_name; /* Directory to save measurers */
	char *model_file; /* File for saving MLP model to */
	int k_fold; /* Cross validation */
	bool single_file; /* Single file instead of file list */
	bool lendian; /* Little-endian mode */
	bool retrain; /* Retraining mode to avoid overwriting of model */
	bool om; /* Direct output measurer (% error) */
	bool nllm; /* ClassNLL measurer*/
	bool tempmean; /* Use temporal mean before logsoft max */
	int sequence_size = 0; /* Size of main -big- data sequence */
	int big_vector_index  = 0; /* Index for adding data to main sequence */
	int tmp_big_vector_index  = 0; /* Temporaneous index for adding data to main sequence */

	char** input_files = NULL; /* List of input files */
    	int n_input_files = 0; /* Number of input files */
    	char** target_tags = NULL; /* List of target tags */
    	int n_target_tags = 0; /* Number of target tags - must equal number of inputs files */

	char** valid_input_files = NULL; /* Validation files list */
    	int valid_n_input_files = 0; /* Validation files number */
    	char** valid_target_tags = NULL; /* Validation targets list */
    	int valid_n_target_tags = 0; /* Validation targets number */
	int valid_sequence_size = 0; /* Size of main -big- data sequence for validation */
	int valid_big_vector_index  = 0; /* Index for adding data to main sequence for validation*/
	int valid_tmp_big_vector_index  = 0; /* Temporaneous index for adding data to main sequence for validation */
	int valid_n_train = 1; /* Number of available frames for validation */
	int valid_vectors_classzero  = 0; /* Vectors from class zero */
	int valid_vectors_classone  = 0; /* Vectors from class one */

	const char *informazioni = "\
	======================================================================\n\
	A.VRI.L MLP 0.94d1 [LIBRA] \n\
	(c)2002-2003 mriyA3, Amos B. <amos.brocco@unifr.ch>\n\
	This software is part of the A.VRI.L speAker VeRIfication Lab Project,\n\
	Bachelor Project @ Departement of Informatics, University of Fribourg\n\
	supervised by Dijana Petrovska (dijana.petrovski@unifr.ch).\n\
	This software is based on the Torch 3 Library (www.torch.ch):\n\
	      R. Collobert, S. Bengio, and J. Marithoz.\n\
	      Torch: a modular machine learning software library.\n\
	      Technical Report IDIAP-RR 02-46, IDIAP, 2002.\n\
	======================================================================\n";

	Allocator *allocator = new Allocator; /* Memory allocation manager class */
	MeanVarNorm *mv_norm = NULL; /* Measurer */
	DiskXFile *model = NULL; /* File object for MLP configuration/model */
	MeasurerList measurers; /* Set of measurers */
	OneHotClassFormat *class_format = NULL; /* Class format for preprocessing */
	Criterion *criterion = NULL; /* Stop criterion for trainer */

	DataSet *data = NULL; /* Input dataset (after preprocessing) */
	Sequence **data_input = NULL; /* Intermediate input sequence */
	Sequence **data_target = NULL; /* Intermediate output sequence */
	HTKDataSet *data_htk = NULL; /* HTK/MFCC input dataset */
	MemoryDataSet *data_mem = NULL; /* Memory dataset for merging inputs & targets */

 	Sequence *data_CLASS = NULL; /* Base output sequence for class tagging */
	Sequence *valid_data_CLASS = NULL; /* Base output sequence for class tagging for validation */

	DataSet *valid_data = NULL; /* Input dataset (after preprocessing) - for validation set */
	Sequence **valid_data_input = NULL; /* Intermediate input sequence - for validation set */
	Sequence **valid_data_target = NULL; /* Intermediate output sequence - for validation set */
	HTKDataSet *valid_data_htk = NULL; /* HTK/MFCC input dataset - for validation set */
	MemoryDataSet *valid_data_mem = NULL; /* Memory dataset for merging inputs & targets - for validation set */

	CmdLine cmd; /* Command line object */
	

/* ========================================================
		FILE LIST LOADER
   ======================================================== */
void scanFiles(const char *filename, char ***filenames_, int *n_files_, Allocator *allocator, bool onefile)
{
	int n_files = 0;

	if(onefile) { /* Only one file (filename is the only file) */
		n_files = 1;
		char **filenames = (char **)allocator->alloc(sizeof(char *)*n_files);
		filenames[0] = (char *)allocator->alloc(256);
		filenames[0] = (char *)filename;
		message("Using single file/tag %s", filename);
		*n_files_ = n_files;
		*filenames_ = filenames;
	}
	else { /* Read from a file list */
		DiskXFile f(filename, "r");
		char bidon[1000];
		do { 	/* Get number of files (funny way) */
			f.gets(bidon,1000);
			n_files++;
		} while (!f.eof());
		n_files--;
		f.rewind();
		/* Allocate space for array */
		char **filenames = (char **)allocator->alloc(sizeof(char *)*n_files);
		for(int i = 0; i < n_files; i++)
			{
			filenames[i] = (char *)allocator->alloc(256);
			f.scanf("%s", filenames[i]);
			}

		message("%d files/tags found in list %s", n_files,filename);
		*n_files_ = n_files;
		*filenames_ = filenames;
	}
}
/* ========================================================
		RANDOM SEED INITIALIZATION
   ======================================================== */
void inizializza_random(void)
{
	message("Initializing random number generator seed");
	if(the_seed == -1)
		Random::seed();
	else
		Random::manualSeed((long)the_seed);
}

/* ========================================================
		CONSOLE INTERFACE MANAGEMENT
   ======================================================== */
void interfaccia(void)
{
		/* Shows help and copyright notice */
		cmd.info(informazioni);

		/* Parameters for training mode */
		cmd.addText("\nValid arguments:");
		cmd.addSCmdArg("inputs", &inputs_file, "the train inputs list of MFCC files or filename in -single mode");
		cmd.addSCmdArg("targets", &targets_file, "the train targets list file or class tag in -single mode");

		cmd.addText("\nTraining options:");
		cmd.addICmdOption("-iter", &max_iter, 100, "max iteration");
		cmd.addRCmdOption("-lr", &learning_rate, 0.01, "learning rate");
		cmd.addRCmdOption("-e", &accuracy, 0.00001, "final accuracy");
		cmd.addRCmdOption("-lrd", &decay, 0, "learning rate decay");
		cmd.addICmdOption("-kfold", &k_fold, -1, "number of folds, if you want to do cross-validation");
		cmd.addRCmdOption("-wd", &weight_decay, 0, "weight decay", true);
		cmd.addBCmdOption("-om", &om, false, "use OutputMeasurer");
		cmd.addBCmdOption("-nllm", &nllm, false, "use ClassNLL measurer");
		cmd.addBCmdOption("-tm", &tempmean, false, "use temporal mean after logsoftmax");
		cmd.addBCmdOption("-rt", &retrain, false, "retraining mode");
		cmd.addBCmdOption("-balance", &balance, false, "equal vectors count for each class");
		cmd.addBCmdOption("-single", &single_file, false, "Simple input file and class");
		cmd.addSCmdOption("-tagzero", &zero_tag, "0", "Class zero tag (anything different will be considered as class one)",true);

		cmd.addText("\nOther options:");
		cmd.addICmdOption("-seed", &the_seed, -1, "the random seed");
		cmd.addSCmdOption("-vilist", &valid_inputs_file, "", "the validation input list file or filename in -single mode");
		cmd.addSCmdOption("-vtlist", &valid_targets_file, "", "the validation target list file or tag in -single mode");
		cmd.addSCmdOption("-dir", &dir_name, ".", "directory to save measures");
		cmd.addSCmdOption("-save", &model_file, "avrilmodel", "the model file");
		cmd.addICmdOption("-hidden", &hidden, 13, "hidden units",true);
		cmd.addBCmdOption("-lendian", &lendian, false, "little endian mode",true);


		/* Parameters for testing mode */
		cmd.addMasterSwitch("--test");
		cmd.addText("\nValid arguments:");
		cmd.addSCmdArg("model", &model_file, "the model file");
		cmd.addSCmdArg("inputs file", &inputs_file, "the test list file");

		cmd.addText("\nOther options:");
		cmd.addICmdOption("-load", &max_load, -1, "max number of examples to load for test");
		cmd.addBCmdOption("-single", &single_file, false, "Simple input file and class");
		cmd.addSCmdOption("-dir", &dir_name, ".", "directory to save measures");
		cmd.addBCmdOption("-om", &om, false, "use OutputMeasurer");
		cmd.addBCmdOption("-nllm", &nllm, false, "use ClassNLL measurer");
}



/* ========================================================
		MAIN
   ======================================================== */
int main(int argc, char **argv)
{
	/* ........................................................
			Console interface management
	........................................................ */
		interfaccia();

		/* Read command line parameters. The return value sets the run mode:
		either training (with 0) or testing (with 1) */
		int mode = cmd.read(argc, argv);

		/* Working directory */
		cmd.setWorkingDirectory(dir_name);

		/* Check endianess for binary data */
		if(!lendian)
			DiskXFile::setBigEndianMode();
		else
			DiskXFile::setLittleEndianMode();

	/* ........................................................
			Main init
	........................................................ */

		if(mode == TRAIN)
			{
			message("A.VRI.L : Training mode");
			inizializza_random();
			}
			else
			{
			message("A.VRI.L : Test mode");
			}

		if(retrain)
			message("Now in retraining mode");

		if((mode == TEST) || retrain)
			{
			model = new(allocator) DiskXFile(model_file, "r");
			message("Loading command line parameters");
			cmd.loadXFile(model);
			}

	/* ........................................................
			Input data loading (Dataset)
	........................................................ */

		/* Process the file lists */
		message("Loading input file list");
    		scanFiles(inputs_file,&input_files,&n_input_files,allocator, single_file);
		if(mode != TEST) {
			message("Loading targets list");
    			scanFiles(targets_file,&target_tags,&n_target_tags,allocator, single_file);
			/* If the number of inputs is different than the targets there is something wrong */
			if(n_input_files != n_target_tags)
				error("Number of input files does not match with number of target tags");
			message("Done, available input files %d, targets %d",n_input_files, n_target_tags);
			}
		else
			message("Done, available input files %d",n_input_files);

		/* First check the final dimension of the sequence */
		for(int k = 0; k < n_input_files;k++)
			{
			data_htk = new(allocator) HTKDataSet(input_files[k], true, -1 , NULL, NULL, false);
			data_htk->setExample(0);
			//message("Frames in file %d/%d (%s) : %d", k+1, n_input_files, input_files[k], data_htk->inputs->n_frames);

			/* For balancing of input vectors */
			if(balance) {
				if(!(strcmp(target_tags[k],zero_tag)))
					load_classzero += data_htk->inputs->n_frames;
				else
					load_classone += data_htk->inputs->n_frames;
				}
			/* Increment vector number */

			sequence_size += data_htk->inputs->n_frames;
			allocator->free(data_htk);
			}

		if(balance) { /* Balance number of vectors */
			message("Not Balanced vectors count: Class zero: %d vectors, Class one: %d vectors", load_classzero, load_classone);
			if(load_classzero < load_classone)
				load_classone = load_classzero;
			else
				load_classzero = load_classone;
			/* New sequence size */
			sequence_size = load_classzero + load_classone;
			/* Set token number for each class */
			vector_tokens[0]=load_classzero;
			vector_tokens[1]=load_classone;
			message("Balanced vectors tokens : %d class zero, %d class one (total %d)",vector_tokens[0], vector_tokens[1], sequence_size);
			}

		/* Sequence_size is the number of vectors contained in files */
		message("Allocating space for two (inputs and targets) sequences of length %d",sequence_size);
		/* Now that we know the size of the data create an empty sequence */
		data_input = (Sequence**) allocator->alloc(sequence_size*sizeof(Sequence *));
		data_target = (Sequence**) allocator->alloc(sequence_size*sizeof(Sequence *));

		message("Extracting vector sequences from files...");
		/* Reprocess every input file to get vectors from */
		for(int k = 0; k < n_input_files;k++)
			{
			/* Inputs MFCC sequence */
			data_htk = new(allocator) HTKDataSet(input_files[k], true, -1 , NULL, NULL, false);
			data_htk->setExample(0);
			n_train = data_htk->inputs->n_frames;
			/* Sequence for outputs (classes)*/
			data_CLASS = new(allocator) Sequence(n_train,2);

			/* Test mode, so class is 0 by default */
			if(mode == TEST) {
				theclass = 0;
				}
			else
				{
				if(!(strcmp(target_tags[k],zero_tag))) /* check for c-lient class zero*/
					{
					theclass = 0;
					}
				else /* else  is w-orld */
					{
					theclass = 1;
					}
				}

			/* Fill the output sequence with 0 1 or 1 0 as class tags */
			for(int v = 0; v < n_train; v++)
				{
				data_CLASS->frames[v][theclass] =  1;
				data_CLASS->frames[v][1-theclass] =  0;
				}

			/* Add (all) vectors from HTK data to input sequence */
			for(int u = 0; u < n_train; u++)
				{
				if((vector_tokens[theclass]>=0) || (!balance))
				{
					/* For each frame/vector create a sequence */
					data_input[int(u + big_vector_index)] = new(allocator) Sequence(1, data_htk->n_inputs);
					/* Insert in this sequence data of the 'u' vector from HTK data */
					data_input[int(u + big_vector_index)]->copyFrom(data_htk->inputs->frames[u]);
					/* For each frame/vector create a sequence */
					data_target[int(u + big_vector_index)] = new(allocator) Sequence(1, 2);
					/* Insert in this sequence data of the 'u' vector from output data */
					data_target[int(u + big_vector_index)]->copyFrom(data_CLASS->frames[u]);
					/* Data from vector is now in the input sequence...  repeat for each vector */
					if(balance)
						{
						vector_tokens[theclass]--;
						vectors_processed++;
						}
				} else {
					u = n_train;
					}
				}
			if(balance)
				message("Input file %d / %d (%s), load %d/%d vectors of size %d, class %d processed (Balanced)",k+1,n_input_files, input_files[k], vectors_processed, n_train, data_htk->n_inputs, theclass);
			else
				message("Input file %d / %d (%s), %d vectors of size %d, class %d processed",k+1,n_input_files, input_files[k], n_train, data_htk->n_inputs, theclass);

			/* Next index for data addition */
			if(balance) {
				big_vector_index += vectors_processed;
				vectors_processed = 0;
				}
			else
				big_vector_index += n_train;
			/* Free memory */
			allocator->free(data_htk);
			allocator->free(data_CLASS);
		}
		message("Total %d vectors loaded ( %d class zero, %d class one)",big_vector_index, load_classzero, load_classone);
		/* Now build a MemoryDataSet */
		data_mem = new(allocator) MemoryDataSet();
		//sequence_size = data_input->n_real_frames;
		message("Memory data Set created... %d frames allocated... now filling...",sequence_size);
		/* Set input sequence */
		data_mem->setInputs(data_input,sequence_size);
		message("Memory data set filled with input data");
		/* Set output sequence */
		data_mem->setTargets(data_target,sequence_size);
		message("Memory data set filled with output data");
		/* Now the dataset should be complete */

	/* ........................................................
			Input normalization and preprocessing
	........................................................ */

		mv_norm = new(allocator) MeanVarNorm(data_mem);
		message("Mean variance normalization set");
		/* If we are in testing mode load normalization parameters from model,
		in order to keep preprocessing of testing data like the one used for training */
		if((mode == TEST) || retrain)
			{
			message("Trying to load normalization parameters from %s",model_file);
			mv_norm->loadXFile(model);
			message("Normalization parameters loaded from %s",model_file);
			}
		/* Now preprocessing */
		data_mem->preProcess(mv_norm);
		message("Data preprocessing done");
		/* We'd like to format using the OneHotClass format, for classification */
		class_format = new(allocator) OneHotClassFormat(NOUTPUTS);
		/* Next apply formatting */
		data = new(allocator) ClassFormatDataSet(data_mem, NOUTPUTS);
		message("Data normalization succeeded");

	/* ........................................................
			MLP Creation
	........................................................ */

		ConnectedMachine avril_mlp;

		message("avril_MLP creation in progress");
		/* Linear layer for input */
		Linear *c1 = new(allocator) Linear(int(data_htk->inputs->frame_size), hidden);
		c1->setROption("weight decay", weight_decay);
		message("  Linear layer created: %d inputs, %d outputs",int(c1->n_inputs),int(c1->n_outputs));
		/* Sigmoidal layer */
		Sigmoid *c2 = new(allocator) Sigmoid(hidden);
		message("  Sigmoidal layer created: %d hidden units",int(c2->n_inputs));
		/* Linear layer for output */
		Linear *c3 = new(allocator) Linear(hidden, NOUTPUTS);
		message("  Linear layer created: %d inputs, %d outputs",int(c3->n_inputs),int(c3->n_outputs));
		c3->setROption("weight decay", weight_decay);
		/* LogSoftMax layer for classification */
		LogSoftMax *c4 = new(allocator) LogSoftMax(NOUTPUTS);
		message("  LogSoftMax layer created: %d outputs",int(c4->n_outputs));


		/* Adding layers to the MLP */
		avril_mlp.addFCL(c1);
		avril_mlp.addFCL(c2);
		avril_mlp.addFCL(c3);
		avril_mlp.addFCL(c4);
		/* If requested, add a temporal mean layer as output */
		if(tempmean)
			{
			TemporalMean *ctm = new(allocator) TemporalMean(NOUTPUTS);
			avril_mlp.addFCL(ctm);
			message("  Using temporal mean as output layer: %d outputs",int(ctm->n_outputs));
			}
		message("  Layers added to MLP");

		/* Create layer connections */
		avril_mlp.build();
		message("avril_MLP creation done");
		/* Back propagation for train */
		avril_mlp.setPartialBackprop();

	/* ........................................................
			Validation dataset (like training dataset)
	........................................................ */

		if(mode == TRAIN)
		{
		/* Check if validation is requested by the user */
		if(strcmp(valid_inputs_file, ""))
			{
			/* Process the file lists */
			message("Loading validation input file list");
			scanFiles(valid_inputs_file,&valid_input_files,&valid_n_input_files,allocator, single_file);
			message("Loading validation targets list");
			scanFiles(valid_targets_file,&valid_target_tags,&valid_n_target_tags,allocator, single_file);
			/* If the number of inputs is different than the targets there is something wrong */
			if(valid_n_input_files != valid_n_target_tags)
				error("Number of input files does not match with number of target tags");
			message("Done, available input files %d, targets %d",valid_n_input_files, valid_n_target_tags);


			/* First check the final dimension of the sequence */
			for(int k = 0; k < valid_n_input_files;k++)
				{
				valid_data_htk = new(allocator) HTKDataSet(valid_input_files[k], true, -1 , NULL, NULL, false);
				valid_data_htk->setExample(0);

				/* For balancing of input vectors */
				if(balance) {
					if(!(strcmp(valid_target_tags[k],zero_tag)))
						valid_load_classzero += valid_data_htk->inputs->n_frames;
					else
						valid_load_classone += valid_data_htk->inputs->n_frames;
					}
				/* Increment vector number */
				valid_sequence_size += valid_data_htk->inputs->n_frames;
				allocator->free(valid_data_htk);
				}

			if(balance) { /* Balance number of vectors */
				message("Not Balanced vectors count: Class zero: %d vectors, Class one: %d vectors", valid_load_classzero, valid_load_classone);
				if(valid_load_classzero < valid_load_classone)
					valid_load_classone = valid_load_classzero;
				else
					valid_load_classzero = valid_load_classone;
				/* New sequence size */
				valid_sequence_size = valid_load_classzero + valid_load_classone;
				/* Set token number for each class */
				valid_vector_tokens[0]=valid_load_classzero;
				valid_vector_tokens[1]=valid_load_classone;
				message("Balanced vectors tokens : %d class zero, %d class one (total %d)",valid_vector_tokens[0], valid_vector_tokens[1], valid_sequence_size);
				}

			/* Sequence_size is the number of vectors contained in files */
			message("Allocating space for two (inputs and targets) sequences of length %d",valid_sequence_size);
			/* Now that we know the size of the data create an empty sequence */
			valid_data_input = (Sequence**) allocator->alloc(valid_sequence_size*sizeof(Sequence *));
			valid_data_target = (Sequence**) allocator->alloc(valid_sequence_size*sizeof(Sequence *));

			message("Extracting vector sequences from files...");
			/* Reprocess every input file to get vectors from */
			for(int k = 0; k < valid_n_input_files;k++)
				{
				/* Inputs MFCC sequence */
				valid_data_htk = new(allocator) HTKDataSet(valid_input_files[k], true, -1 , NULL, NULL, false);
				valid_data_htk->setExample(0);
				valid_n_train = valid_data_htk->inputs->n_frames;
				/* Sequence for outputs (classes)*/
				valid_data_CLASS = new(allocator) Sequence(valid_n_train,2);

				/* Test mode, so class is 0 by default */
				if(!(strcmp(valid_target_tags[k],zero_tag))) /* check for c-lient class zero*/
					{
					valid_theclass = 0;
					}
				else /* else  is w-orld */
					{
					valid_theclass = 1;
					}

				/* Fill the output sequence with 0 1 or 1 0 as class tags */
				for(int v = 0; v < valid_n_train; v++)
					{
					valid_data_CLASS->frames[v][valid_theclass] =  1;
					valid_data_CLASS->frames[v][1-valid_theclass] =  0;
					}

				/* Add (all) vectors from HTK data to input sequence */
				for(int u = 0; u < valid_n_train; u++)
					{
					if((valid_vector_tokens[valid_theclass]>=0) || (!balance))
					{
						/* For each frame/vector create a sequence */
						valid_data_input[int(u + valid_big_vector_index)] = new(allocator) Sequence(1, valid_data_htk->n_inputs);
						/* Insert in this sequence data of the 'u' vector from HTK data */
						valid_data_input[int(u + valid_big_vector_index)]->copyFrom(valid_data_htk->inputs->frames[u]);
						/* For each frame/vector create a sequence */
						valid_data_target[int(u + valid_big_vector_index)] = new(allocator) Sequence(1, 2);
						/* Insert in this sequence data of the 'u' vector from output data */
						valid_data_target[int(u + valid_big_vector_index)]->copyFrom(valid_data_CLASS->frames[u]);
						/* Data from vector is now in the input sequence...  repeat for each vector */
						if(balance)
							{
							valid_vector_tokens[valid_theclass]--;
							valid_vectors_processed++;
							}
					} else {
						u = valid_n_train;
						}
					}
				if(balance)
					message("Input file %d / %d (%s), load %d/%d vectors of size %d, class %d processed (Balanced)",k+1,valid_n_input_files, valid_input_files[k], valid_vectors_processed, valid_n_train, valid_data_htk->n_inputs, valid_theclass);
				else
					message("Input file %d / %d (%s), %d vectors of size %d, class %d processed",k+1,valid_n_input_files, valid_input_files[k], valid_n_train, valid_data_htk->n_inputs, valid_theclass);

				/* Next index for data addition */
				if(balance) {
					valid_big_vector_index += valid_vectors_processed;
					valid_vectors_processed = 0;
					}
				else
					valid_big_vector_index += valid_n_train;
				/* Free memory */
				allocator->free(valid_data_htk);
				allocator->free(valid_data_CLASS);
			}
			message("Total %d vectors loaded ( %d class zero, %d class one)",valid_big_vector_index, valid_load_classzero, valid_load_classone);

			/* Now build a MemoryDataSet */
			valid_data_mem = new(allocator) MemoryDataSet();
			message("Memory data Set created... %d frames allocated... now filling...",valid_sequence_size);
			/* Set input sequence */
			valid_data_mem->setInputs(valid_data_input,valid_sequence_size);
			message("Memory data set filled with input data");
			/* Set output sequence */
			valid_data_mem->setTargets(valid_data_target,valid_sequence_size);
			message("Memory data set filled with output data");
			/* Now the dataset should be complete */
			valid_data_mem->preProcess(mv_norm);
			/* Now format data */
			valid_data = new(allocator) ClassFormatDataSet(valid_data_mem,NOUTPUTS);
			message("Validation dataset loaded");
			}
		}

		/* If in test or retrain mode, load MLP model */
		if(retrain || (mode == TEST))
			{
    			message("Loading model (weight parameters) from %s",model_file);
			avril_mlp.loadXFile(model);
			}

	/* ........................................................
			Measurers
	........................................................ */

		/* Measurers for train with validation file */
		if((mode == TRAIN) && strcmp(valid_inputs_file, ""))
			{
			if(nllm)
				{
				/* Create a new measurer for validaton and add it to measurers */
				ClassNLLMeasurer *valid_nll_class_meas = new(allocator) ClassNLLMeasurer(avril_mlp.outputs, valid_data, class_format, cmd.getXFile("the_valid_class_nll"));
				measurers.addNode(valid_nll_class_meas);
				message("Measurer NLL added for validation data set");
				}

			if(om)
				{
				OutputMeasurer *valid_class_meas = new(allocator) OutputMeasurer(valid_data, cmd.getXFile("the_valid_class_out"));
				valid_class_meas->addSequence(avril_mlp.outputs);
				measurers.addNode(valid_class_meas);
				message("Measurer Output added for validation data set");
				}
			}

		/* Create a new Negative Log Likehood measurer and add it to measurer list */
		if(nllm)
			{
			ClassNLLMeasurer *nll_class_meas = new(allocator) ClassNLLMeasurer(avril_mlp.outputs, data, class_format, cmd.getXFile("the_class_nll"));
			measurers.addNode(nll_class_meas);
			message("Measurer NLL added for training data set");
			}

		/* Create a new % error output measurer and add it to measurer list */
		if(om)
			{
			OutputMeasurer *class_meas = new(allocator) OutputMeasurer(data, cmd.getXFile("the_class_out"));
			class_meas->addSequence(avril_mlp.outputs);
			measurers.addNode(class_meas);
			message("Measurer Output added for training data set");
			}
	/* ........................................................
			Train : Criterion
	........................................................ */

		/* Criterion for the StochasticGradient trainer (managed with a NLL measurer) */
		criterion = new(allocator) ClassNLLCriterion(class_format);
		message("NLL Criterion created");
		/*  Trainer for classification */
		StochasticGradient trainer(&avril_mlp, criterion);
		message("Trainer initialized");

		if(mode == TRAIN)
		{
			trainer.setIOption("max iter", max_iter);
			trainer.setROption("end accuracy", accuracy);
			trainer.setROption("learning rate", learning_rate);
			trainer.setROption("learning rate decay", decay);
			message("Maximum iteration %d, end accuracy %f, learning rate %f, learning rate decay %f",max_iter,accuracy,learning_rate,decay);
			message("Trainer options set");
		}



	/* ........................................................
			Train / Test
	........................................................ */

			if(mode == TRAIN)
			{
				if(k_fold <= 0)
				{
					message("Normal training for class %d",theclass);
					/* Train the neural network ... */
					trainer.train(data, &measurers);
					message("Train succeeded");

					/* If requested save the model */
					if(strcmp(model_file, ""))
					{
						allocator->free(model);
						DiskXFile model_(model_file, "w");
						cmd.saveXFile(&model_);
						mv_norm->saveXFile(&model_);
						avril_mlp.saveXFile(&model_);
						message("Model saved to %s",model_file);
					}
				}
				else
				{
					/* Train cross validation */
					message("Using cross validation");
					KFold k(&trainer, k_fold);
					k.crossValidate(data, NULL, &measurers);
				}
			}
			else
			{
			trainer.test(&measurers); /* Testing mode */
			message("Test succeeded");
			}
		/* Unallocate memory resources */
		message("Unallocating space and exiting...");
		delete allocator;
		message("...done");
		/* That's all folks ! */
		return(0);
	}
